package cn.com.tenlion.systembase.service.organization;

import cn.com.tenlion.systembase.pojo.bos.organization.OrganizationBO;
import cn.com.tenlion.systembase.pojo.dtos.organization.OrganizationDTO;
import cn.com.tenlion.systembase.pojo.pos.organization.OrganizationPO;
import cn.com.tenlion.systembase.pojo.vos.organization.OrganizationVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IOrganizationService
 * @Description: 社会组织
 * @Author: CodeFactory
 * @Date: 2021-11-04 15:17:38
 * @Version: 3.0
 **/
public interface IOrganizationService {

    /**
     * 新增社会组织
     *
     * @param organizationVO
     * @return
     */
    void save(OrganizationVO organizationVO);

    /**
     * 新增社会组织
     *
     * @param token
     * @param organizationVO
     * @return
     */
    void save(String token, OrganizationVO organizationVO);

    /**
     * 新增社会组织
     *
     * @param organizationVO
     * @return organizationId
     */
    String saveReturnId(OrganizationVO organizationVO);

    /**
     * 新增社会组织
     *
     * @param token
     * @param organizationVO
     * @return organizationId
     */
    String saveReturnId(String token, OrganizationVO organizationVO);

    /**
     * 删除社会组织
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除社会组织
     *
     * @param token
     * @param ids   id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除社会组织（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改社会组织
     *
     * @param organizationId
     * @param organizationVO
     * @return
     */
    void update(String organizationId, OrganizationVO organizationVO);

    /**
     * 修改社会组织
     *
     * @param token
     * @param organizationId
     * @param organizationVO
     * @return
     */
    void update(String token, String organizationId, OrganizationVO organizationVO);

    /**
     * 社会组织详情
     *
     * @param params 参数Map
     * @return
     */
    OrganizationDTO get(Map<String, Object> params);

    /**
     * 社会组织详情
     *
     * @param organizationId
     * @return
     */
    OrganizationDTO get(String organizationId);

    /**
     * 社会组织详情
     *
     * @param params 参数Map
     * @return
     */
    OrganizationBO getBO(Map<String, Object> params);

    /**
     * 社会组织详情
     *
     * @param organizationId
     * @return
     */
    OrganizationBO getBO(String organizationId);

    /**
     * 社会组织详情
     *
     * @param params 参数Map
     * @return
     */
    OrganizationPO getPO(Map<String, Object> params);

    /**
     * 社会组织详情
     *
     * @param organizationId
     * @return
     */
    OrganizationPO getPO(String organizationId);

    /**
     * 社会组织详情
     *
     * @param businessRegNo
     * @return
     */
    OrganizationPO getPOByBusinessRegNo(String businessRegNo);

    /**
     * 社会组织列表
     *
     * @param params
     * @return
     */
    List<OrganizationDTO> list(Map<String, Object> params);

    /**
     * 社会组织列表
     *
     * @param params
     * @return
     */
    List<OrganizationBO> listBO(Map<String, Object> params);

    /**
     * 社会组织列表
     *
     * @param params
     * @return
     */
    List<OrganizationPO> listPO(Map<String, Object> params);

    /**
     * 社会组织分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<OrganizationDTO>> listPage(ListPage page);

    /**
     * 社会组织统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, OrganizationVO organizationVO);

    void updateKafka(String uid, OrganizationVO organizationVO);

    void deleteKafka(String uid);

}